"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name2 in all)
    __defProp(target, name2, { get: all[name2], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  default: () => src_default
});
module.exports = __toCommonJS(src_exports);
var import_vite = require("vite");
var import_posthtml = __toESM(require("posthtml"));
var import_promises = __toESM(require("fs/promises"));
var import_node_path = __toESM(require("path"));
var import_core = require("@babel/core");

// package.json
var name = "vite-plugin-legacy-dev";

// src/index.ts
var COREJS_PATH = "/@legacydev/corejs3";
var FETCH_PATH = "/@legacydev/fetch";
var SYSTEMJS_PATH = "/@legacydev/systemjs";
var WEBCOMPONENTS_PATH = "/@legacydev/webcomponents";
var helpers = /* @__PURE__ */ new Map([
  [COREJS_PATH, "core-js-bundle/index.js"],
  [FETCH_PATH, "whatwg-fetch/dist/fetch.umd.js"],
  [WEBCOMPONENTS_PATH, "@webcomponents/webcomponentsjs/webcomponents-bundle.js"],
  [SYSTEMJS_PATH, "systemjs/dist/system.js"]
]);
var transformESMToSystemjs = (code, filename) => (0, import_core.transformAsync)(code, {
  presets: [
    [
      "@babel/preset-env",
      {
        modules: "systemjs",
        useBuiltIns: false
      }
    ]
  ],
  filename
});
var vitePluginLegacyDev = () => {
  let server;
  let config;
  const vitePluginLegacyDevPostTransform = {
    name: "vite-plugin-legacy-dev-post-transform",
    async transform(code, id) {
      if (new URLSearchParams(id.split("?")[1] || "").has("direct"))
        return;
      const transformResult = await transformESMToSystemjs(code, id);
      if (transformResult && transformResult.code) {
        return {
          code: transformResult.code
        };
      }
    }
  };
  return {
    name: "vite-plugin-legacy-dev",
    apply: "serve",
    enforce: "post",
    configResolved(_config) {
      config = _config;
      config.plugins.push(vitePluginLegacyDevPostTransform);
    },
    configureServer(_server) {
      server = _server;
      server.middlewares.use(async (req, res, next) => {
        if (req.url && helpers.has(req.url)) {
          const content = await import_promises.default.readFile(
            import_node_path.default.resolve(config.root, `node_modules/${name}/node_modules`, helpers.get(req.url)),
            "utf-8"
          );
          return (0, import_vite.send)(req, res, content.toString(), "js", {});
        }
        next();
      });
    },
    transformIndexHtml: {
      enforce: "post",
      async transform(html) {
        const result = await (0, import_posthtml.default)([
          (tree) => {
            tree.match({ tag: "script" }, (node) => {
              const attrs = node.attrs;
              if (attrs && attrs.type === "module") {
                attrs.type = "systemjs-module";
              }
              return node;
            });
          }
        ]).process(html);
        return {
          html: result.html,
          tags: Array.from(helpers.keys()).map((src) => ({
            tag: "script",
            injectTo: "head-prepend",
            attrs: {
              src
            }
          }))
        };
      }
    }
  };
};
var src_default = vitePluginLegacyDev;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
